OpenVDB: RootNode< ChildT > Class Template Reference

OpenVDB 9.1.0

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Friends | List of all members
RootNode< ChildT > Class Template Reference

Top-most node of the VDB tree structure. More...

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for RootNode< ChildT >:

## Public Types
using | DataType = RootData< ChildT >
using | LeafNodeType = typename ChildT::LeafNodeType
using | ChildNodeType = ChildT
using | RootType = RootNode< ChildT >
using | ValueType = typename DataType::ValueT
using | FloatType = typename DataType::StatsT
using | BuildType = typename DataType::BuildT
using | CoordType = typename ChildT::CoordType
using | AccessorType = DefaultReadAccessor< BuildType >
using | Tile = typename DataType::Tile

## Public Member Functions
| RootNode ()=delete
| This class cannot be constructed or deleted. More...
| RootNode (const RootNode &)=delete
RootNode & | operator= (const RootNode &)=delete
| ~RootNode ()=delete
AccessorType | getAccessor () const
DataType * | data ()
const DataType * | data () const
const BBox< CoordType > & | bbox () const
| Return a const reference to the index bounding box of all the active values in this tree, i.e. in all nodes of the tree. More...
const ValueType & | background () const
| Return the total number of active voxels in the root and all its child nodes. More...
const uint32_t & | tileCount () const
| Return the number of tiles encoded in this root node. More...
const ValueType & | minimum () const
| Return a const reference to the minimum active value encoded in this root node and any of its child nodes. More...
const ValueType & | maximum () const
| Return a const reference to the maximum active value encoded in this root node and any of its child nodes. More...
const FloatType & | average () const
| Return a const reference to the average of all the active values encoded in this root node and any of its child nodes. More...
FloatType | variance () const
| Return the variance of all the active values encoded in this root node and any of its child nodes. More...
const FloatType & | stdDeviation () const
| Return a const reference to the standard deviation of all the active values encoded in this root node and any of its child nodes. More...
uint64_t | memUsage () const
| Return the actual memory footprint of this root node. More...
ValueType | getValue (const CoordType &ijk) const
| Return the value of the given voxel. More...
bool | isActive (const CoordType &ijk) const
bool | isEmpty () const
| Return true if this RootNode is empty, i.e. contains no values or nodes. More...
bool | probeValue (const CoordType &ijk, ValueType &v) const
const LeafNodeType * | probeLeaf (const CoordType &ijk) const

## Static Public Member Functions
static uint64_t | memUsage (uint32_t tableSize)
| Return the expected memory footprint in bytes with the specified number of tiles. More...

## Static Public Attributes
static constexpr bool | FIXED_SIZE = DataType::FIXED_SIZE
static constexpr uint32_t | LEVEL = 1 + ChildT::LEVEL

## Friends
template<typename , int , int , int >
class | ReadAccessor
template<typename >
class | Tree

## Detailed Description

template<typename ChildT>
class nanovdb::RootNode< ChildT >

Top-most node of the VDB tree structure.

## Member Typedef Documentation

## ◆ AccessorType

using AccessorType = DefaultReadAccessor<BuildType>

## ◆ BuildType

using BuildType = typename DataType::BuildT

## ◆ ChildNodeType

using ChildNodeType = ChildT

## ◆ CoordType

using CoordType = typename ChildT::CoordType

## ◆ DataType

using DataType = RootData<ChildT>

## ◆ FloatType

using FloatType = typename DataType::StatsT

## ◆ LeafNodeType

using LeafNodeType = typename ChildT::LeafNodeType

## ◆ RootType

using RootType = RootNode<ChildT>

## ◆ Tile

using Tile = typename DataType::Tile

## ◆ ValueType

using ValueType = typename DataType::ValueT

## Constructor & Destructor Documentation

## ◆ RootNode() [1/2]

RootNode | ( |  | ) |
| delete

This class cannot be constructed or deleted.

## ◆ RootNode() [2/2]

RootNode | ( | const RootNode< ChildT > & |  | ) |
| delete

## ◆ ~RootNode()

~RootNode | ( |  | ) |
| delete

## Member Function Documentation

## ◆ average()

const FloatType & average | ( |  | ) | const
| inline

Return a const reference to the average of all the active values encoded in this root node and any of its child nodes.

## ◆ background()

const ValueType & background | ( |  | ) | const
| inline

Return the total number of active voxels in the root and all its child nodes.

Return a const reference to the background value, i.e. the value associated with any coordinate location that has not been set explicitly.

## ◆ bbox()

const BBox< CoordType > & bbox | ( |  | ) | const
| inline

Return a const reference to the index bounding box of all the active values in this tree, i.e. in all nodes of the tree.

## ◆ data() [1/2]

DataType * data | ( |  | ) |
| inline

## ◆ data() [2/2]

const DataType * data | ( |  | ) | const
| inline

## ◆ getAccessor()

AccessorType getAccessor | ( |  | ) | const
| inline

## ◆ getValue()

ValueType getValue | ( | const CoordType & | ijk | ) | const
| inline

Return the value of the given voxel.

## ◆ isActive()

bool isActive | ( | const CoordType & | ijk | ) | const
| inline

## ◆ isEmpty()

bool isEmpty | ( |  | ) | const
| inline

Return true if this RootNode is empty, i.e. contains no values or nodes.

## ◆ maximum()

const ValueType & maximum | ( |  | ) | const
| inline

Return a const reference to the maximum active value encoded in this root node and any of its child nodes.

## ◆ memUsage() [1/2]

uint64_t memUsage | ( |  | ) | const
| inline

Return the actual memory footprint of this root node.

## ◆ memUsage() [2/2]

static uint64_t memUsage | ( | uint32_t | tableSize | ) |
| inlinestatic

Return the expected memory footprint in bytes with the specified number of tiles.

## ◆ minimum()

const ValueType & minimum | ( |  | ) | const
| inline

Return a const reference to the minimum active value encoded in this root node and any of its child nodes.

## ◆ operator=()

RootNode & operator= | ( | const RootNode< ChildT > & |  | ) |
| delete

## ◆ probeLeaf()

const LeafNodeType * probeLeaf | ( | const CoordType & | ijk | ) | const
| inline

## ◆ probeValue()

bool probeValue | ( | const CoordType & | ijk,
|  | ValueType & | v
| ) |  | const
| inline

## ◆ stdDeviation()

const FloatType & stdDeviation | ( |  | ) | const
| inline

Return a const reference to the standard deviation of all the active values encoded in this root node and any of its child nodes.

## ◆ tileCount()

const uint32_t & tileCount | ( |  | ) | const
| inline

Return the number of tiles encoded in this root node.

## ◆ variance()

FloatType variance | ( |  | ) | const
| inline

Return the variance of all the active values encoded in this root node and any of its child nodes.

## Friends And Related Function Documentation

## ◆ ReadAccessor

friend class ReadAccessor
| friend

## ◆ Tree

friend class Tree
| friend

## Member Data Documentation

## ◆ FIXED_SIZE

constexpr bool FIXED_SIZE = DataType::FIXED_SIZE
| staticconstexpr

## ◆ LEVEL

constexpr uint32_t LEVEL = 1 + ChildT::LEVEL
| staticconstexpr